/***************************************************************************
 *   Copyright (C) 2008 by S. MANKOWSKI / G. DE BURE skrooge@miraks.com    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>  *
 ***************************************************************************/
/** @file
 * Display a summary of your information
 *
 * @author Guillaume DE BURE
 */
#include "skgdashboard2plugin.h"
#include "skgdashboard2pluginwidget.h"
#include "skgdashboard2_settings.h"
#include "skgtraces.h"

#include <kactioncollection.h>
#include <kstandardaction.h>

K_PLUGIN_FACTORY(SKGDASHBOARD2PluginFactory, registerPlugin<SKGDASHBOARD2Plugin>();)
K_EXPORT_PLUGIN(SKGDASHBOARD2PluginFactory("skrooge_dashboard2", "skrooge_dashboard2"))

SKGDASHBOARD2Plugin::SKGDASHBOARD2Plugin(QObject* iParent, const QVariantList& /*iArg*/) : SKGInterfacePlugin(iParent)
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::SKGDASHBOARD2Plugin");
}

SKGDASHBOARD2Plugin::~SKGDASHBOARD2Plugin()
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::~SKGDASHBOARD2Plugin");
        currentBankDocument=NULL;
}

void SKGDASHBOARD2Plugin::setupActions(SKGDocument* iDocument, const QStringList& iArgument)
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::setupActions");
        Q_UNUSED(iArgument);

        currentBankDocument=iDocument;


        setComponentData( SKGDASHBOARD2PluginFactory::componentData() );
        setXMLFile("skrooge_dashboard2.rc");

        //Create yours actions here
}

void SKGDASHBOARD2Plugin::refresh()
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::refresh");
}

void SKGDASHBOARD2Plugin::close()
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::close");
}

SKGTabPage* SKGDASHBOARD2Plugin::getWidget()
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::getWidget");
        return new SKGDASHBOARD2PluginWidget(currentBankDocument);
}

QWidget* SKGDASHBOARD2Plugin::getPreferenceWidget()
{
        SKGTRACEIN(10, "SKGDASHBOARD2Plugin::getPreferenceWidget");
        QWidget* widget=new QWidget();
        ui.setupUi(widget);

        return widget;
}

KConfigSkeleton* SKGDASHBOARD2Plugin::getPreferenceSkeleton()
{
        return skgdashboard2_settings::self();
}

SKGError SKGDASHBOARD2Plugin::savePreferences() const
{
        return SKGError();
}

QString SKGDASHBOARD2Plugin::title() const
{
        return i18n("plasma dashboard");
}

QString SKGDASHBOARD2Plugin::icon() const
{
        return "plasma";
}

QString SKGDASHBOARD2Plugin::statusTip () const
{
        return i18n("Display a summary of your information");
}

QString SKGDASHBOARD2Plugin::toolTip () const
{
        return i18n("Display a summary of your information");
}


int SKGDASHBOARD2Plugin::getOrder() const
{
        return 999;
}

QStringList SKGDASHBOARD2Plugin::tips() const
{
        QStringList output;
        output.push_back(i18n("<p>... the plasma dashboard is fully customizable</p>"));
        return output;
}

bool SKGDASHBOARD2Plugin::isInContext() const
{
        return true;
}

#include "skgdashboard2plugin.moc"
